﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;
using System.Windows.Automation;
using System.Windows.Markup;
using System.Threading;
using System.Globalization;

namespace testGridTypes
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        ObservableCollection<Types> obs = new ObservableCollection<Types>();
        public static ObservableCollection<Types> Gen()
        {
            ObservableCollection<Types> generated = new ObservableCollection<Types>();
            for (int i = 0; i < 15; i++)
            {
                generated.Add(new Types(i,double.Parse(i.ToString()), decimal.Parse(i.ToString()), new DateTime()));
            }
            return generated;
        }
        public Window1()
        {
            InitializeComponent();
            obs = Gen();
            xamDataGrid1.DataSource = obs;

            xamDataGrid1.PreviewKeyDown += new KeyEventHandler(xamDataGrid1_PreviewKeyDown);
            xamDataGrid1.KeyDown += new KeyEventHandler(xamDataGrid1_KeyDown);
            xamDataGrid1.PreviewKeyUp += new KeyEventHandler(xamDataGrid1_PreviewKeyUp);
            xamDataGrid1.KeyUp += new KeyEventHandler(xamDataGrid1_KeyUp);

        }

        void xamDataGrid1_KeyUp(object sender, KeyEventArgs e)
        {
           if ((e.Key == Key.R || e.Key == Key.C) && Keyboard.Modifiers == ModifierKeys.Alt)
                System.Windows.MessageBox.Show("Got it");
        }

        void xamDataGrid1_PreviewKeyUp(object sender, KeyEventArgs e)
        {
            if ((e.Key == Key.R || e.Key == Key.C) && Keyboard.Modifiers == ModifierKeys.Alt)
                System.Windows.MessageBox.Show("Got it");
        }

        void xamDataGrid1_KeyDown(object sender, KeyEventArgs e)
        {

            if ((e.Key == Key.R || e.Key == Key.C) && Keyboard.Modifiers == ModifierKeys.Alt)
                System.Windows.MessageBox.Show("Got it");
        }

        void xamDataGrid1_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if ((e.Key == Key.R || e.Key == Key.C) && Keyboard.Modifiers == ModifierKeys.Alt)
                System.Windows.MessageBox.Show("Got it");
        }
        public class Types
        {
            public int nInt {get;set;}
            public double nDouble { get; set; }
            public decimal nDec {get;set;}
            public DateTime nDate {get;set;}
            public Types(int i,double dO, decimal d, DateTime date)
            {
                this.nInt = i;
                this.nDec = d;
                this.nDate = date;
                this.nDouble = dO;
            }
           
        }

        private void xamDataGrid1_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
        {

            
                //Converter c = new Converter();
                //var editor = e.Editor as XamNumericEditor;
                //editor.Background = (c.Convert(editor.Value.ToString(), typeof(Decimal) , new object(), System.Globalization.CultureInfo.CurrentCulture)) as Brush;
            
        }



        private void button1_Click(object sender, RoutedEventArgs e)
        {
            foreach(Field f in xamDataGrid1.FieldLayouts[0].Fields)
            {
                f.IsSelected = true;

            }
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            CellValuePresenter cvp = CellValuePresenter.FromCell(xamDataGrid1.ActiveCell);
            var x = cvp.Editor;
            x.FormatProvider = new CultureInfo("bg-BG");
        }

        private void xamDataGrid1_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {
            DependencyObject source = e.OriginalSource as DependencyObject;

            if (source == null)

                return;

            CellValuePresenter drp = Infragistics.Windows.Utilities.GetAncestorFromType(source, typeof(CellValuePresenter), true) as CellValuePresenter;

            if (drp == null)

                return;

            else
            {
                drp.IsActive = true;
            }
        }


    }
    public class Converter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                int number=0;
                int.TryParse(value.ToString(), out number);
                if (number == 0)
                    return Brushes.Red;
                if (number >= 0 && number <= 5)
                    return Brushes.Yellow;
                if (number > 5)
                    return Brushes.Green;
            }
            return Brushes.Black;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
